package pro.litvinovg.w2phtml.gui;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.HashMap;

import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import static pro.litvinovg.w2phtml.gui.Contstants.*;
import net.miginfocom.swing.MigLayout;

public class RDFPanel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private UIPreferences preferences;
	private HashMap<String, Component> configuration;
	private JComboBox cbox_image_resolution_1;
	private JCheckBox cb_Pagination_1;
	private JCheckBox cb_convertToPx_1;
	private JCheckBox cb_EmbedRaster_1;
	private JCheckBox cb_EmbedVectorImages_1;
	private JTextField tf_FilterLetterSpacing_1;
	private JCheckBox cb_InlineStyles_1;
	private JLabel lb_TargetFormat_1;
	private JTextField tf_OutputFile_1;
	private JTextField tf_metadataPath_1;
	private JTextField tf_inputFile_1;
	private JButton btnChooseFile;
	private JButton btn_metadataChoose_1;
	private JButton btn_ChooseOutputFile_1;
	private JTextField tf_pageBreakInlineStyle_1;
	private JTextField tf_Scale_1;
	private JComboBox cbox_type_1;
	private JCheckBox cb_IgnoreEmptyParagraphs_1;
	private JCheckBox cb_UseMathJax_1;
	private JCheckBox cb_IgnoreHardLineBreaks_1;

	public RDFPanel() {
		this.preferences = PreferencesStorage.getDefaultRDF(null);
		this.configuration = new HashMap<String, Component>();
		initComponents();
	}
	
	public RDFPanel(HashMap<String, Component> configuration, UIPreferences preferences) {
		this.configuration = configuration;
		this.preferences = preferences;
		initComponents();
	}

	private void initComponents() {
		JLabel lb_FilterLetterSpacing = new JLabel(Localizer.get(LABEL_MIN_LETTER_SPACING));
		JLabel lb_TargetFormat = addTargetFormat(RDF_TARGET_FORMAT,configuration);
		JLabel lb_Scale = new JLabel(Localizer.get(LABEL_SCALE));
		JLabel lb_FilePath = new JLabel(Localizer.get(LABEL_INPUT_FILE_PATH));
		JLabel lb_TargetFormat_description = new JLabel(Localizer.get(LABEL_TARGET_FORMAT));
		JLabel lb_OutFilePath = new JLabel(Localizer.get(OUTPUT_FILE_PATH));
		JLabel lb_ImageResolution = new JLabel(Localizer.get(LABEL_IMAGE_RESOLUTION));
		JLabel lb_type = new JLabel(Localizer.get(LABEL_TYPE));
		JLabel lb_metadataFilePath = new JLabel(Localizer.get(LABEL_METADATA_PATH));
		JLabel lb_pageBreakInlineStyle = new JLabel(Localizer.get(LABEL_BREAK_STYLE));
		
		JTextField tf_OutputFile = addOutputFileTextField(configuration,preferences);
		JTextField tf_FilterLetterSpacing = addLetterSpacingFilter(configuration,preferences);	
		JTextField tf_Scale = addScaling(configuration,preferences);
		JTextField tf_inputFile = addInputFile(configuration,preferences);
		JTextField tf_metadataPath = addMetadataPath(configuration);
		JTextField tf_pageBreakInlineStyle = addPageBreakStyle(configuration,preferences);
		
		JCheckBox cb_UseMathJax = addMathJaxCB(configuration,preferences);
		JCheckBox cb_IgnoreEmptyParagraphs = addIgnoreEmptyParsCB(configuration,preferences);
		JCheckBox cb_IgnoreHardLineBreaks = addIgnoreHardLineBreaks(configuration,preferences);
		JCheckBox cb_InlineStyles = addInlineStyles(configuration,preferences);
		cb_InlineStyles.setEnabled(false);
		JCheckBox cb_EmbedVectorImages = addEmbedVectorImages(configuration,preferences);
		cb_EmbedVectorImages.setEnabled(false);
		JCheckBox cb_EmbedRaster = addEmbedRasterImages(configuration,preferences);
		cb_EmbedRaster.setEnabled(false);
		JCheckBox cb_convertToPx = addConvertToPX(configuration,preferences);
		JCheckBox cb_Pagination = addPagination(configuration,preferences);

		JComboBox cbox_image_resolution = addImageResolution(configuration,preferences);
		JComboBox cbox_type = addPubTypes(configuration, preferences);

		JButton btn_ChooseOutputFile = addChooseOutputButton(tf_OutputFile, RDF_FILE_EXTENSION);
		JButton btn_ChooseFile = addChooseFile(tf_OutputFile, tf_inputFile, tf_metadataPath);
		JButton btn_metadataChoose = addMetadataButton(tf_metadataPath);
		GroupLayout groupLayout = new GroupLayout(this);
		groupLayout.setHorizontalGroup(
			groupLayout.createParallelGroup(Alignment.LEADING)
				.addGroup(groupLayout.createSequentialGroup()
					.addGap(6)
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addGroup(groupLayout.createSequentialGroup()
							.addComponent(lb_metadataFilePath, GroupLayout.PREFERRED_SIZE, 198, GroupLayout.PREFERRED_SIZE)
							.addGap(12)
							.addComponent(tf_metadataPath_1, GroupLayout.DEFAULT_SIZE, 448, Short.MAX_VALUE)
							.addGap(19)
							.addComponent(btn_metadataChoose_1, GroupLayout.PREFERRED_SIZE, 115, GroupLayout.PREFERRED_SIZE))
						.addGroup(groupLayout.createSequentialGroup()
							.addComponent(lb_OutFilePath, GroupLayout.PREFERRED_SIZE, 198, GroupLayout.PREFERRED_SIZE)
							.addGap(12)
							.addComponent(tf_OutputFile_1, GroupLayout.DEFAULT_SIZE, 448, Short.MAX_VALUE)
							.addGap(19)
							.addComponent(btn_ChooseOutputFile_1, GroupLayout.PREFERRED_SIZE, 115, GroupLayout.PREFERRED_SIZE))
						.addGroup(groupLayout.createSequentialGroup()
							.addComponent(lb_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, 198, GroupLayout.PREFERRED_SIZE)
							.addGap(12)
							.addComponent(tf_pageBreakInlineStyle_1, GroupLayout.DEFAULT_SIZE, 582, Short.MAX_VALUE))
						.addGroup(groupLayout.createSequentialGroup()
							.addComponent(lb_type, GroupLayout.PREFERRED_SIZE, 71, GroupLayout.PREFERRED_SIZE)
							.addGap(27)
							.addComponent(cbox_type_1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
						.addComponent(cb_InlineStyles_1)
						.addComponent(cb_EmbedVectorImages_1)
						.addComponent(cb_EmbedRaster_1)
						.addComponent(cb_convertToPx_1, GroupLayout.PREFERRED_SIZE, 658, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_IgnoreHardLineBreaks_1, GroupLayout.PREFERRED_SIZE, 382, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_IgnoreEmptyParagraphs_1, GroupLayout.PREFERRED_SIZE, 382, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_UseMathJax_1, GroupLayout.PREFERRED_SIZE, 382, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_Pagination_1, GroupLayout.PREFERRED_SIZE, 382, GroupLayout.PREFERRED_SIZE)
						.addGroup(groupLayout.createSequentialGroup()
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(lb_ImageResolution, GroupLayout.PREFERRED_SIZE, 245, GroupLayout.PREFERRED_SIZE)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(cbox_image_resolution_1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
						.addGroup(groupLayout.createSequentialGroup()
							.addComponent(lb_Scale, GroupLayout.PREFERRED_SIZE, 83, GroupLayout.PREFERRED_SIZE)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(tf_Scale_1, GroupLayout.PREFERRED_SIZE, 60, GroupLayout.PREFERRED_SIZE))
						.addGroup(groupLayout.createSequentialGroup()
							.addComponent(lb_FilterLetterSpacing)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(tf_FilterLetterSpacing_1, GroupLayout.PREFERRED_SIZE, 52, GroupLayout.PREFERRED_SIZE))
						.addGroup(groupLayout.createSequentialGroup()
							.addGroup(groupLayout.createParallelGroup(Alignment.TRAILING, false)
								.addComponent(lb_TargetFormat_description, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(lb_FilePath, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 198, Short.MAX_VALUE))
							.addGap(12)
							.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
								.addComponent(lb_TargetFormat_1, GroupLayout.PREFERRED_SIZE, 29, GroupLayout.PREFERRED_SIZE)
								.addGroup(groupLayout.createSequentialGroup()
									.addComponent(tf_inputFile_1, GroupLayout.DEFAULT_SIZE, 448, Short.MAX_VALUE)
									.addGap(19)
									.addComponent(btnChooseFile, GroupLayout.PREFERRED_SIZE, 115, GroupLayout.PREFERRED_SIZE)))))
					.addGap(6))
		);
		groupLayout.setVerticalGroup(
			groupLayout.createParallelGroup(Alignment.LEADING)
				.addGroup(groupLayout.createSequentialGroup()
					.addGap(6)
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addComponent(lb_TargetFormat_description)
						.addComponent(lb_TargetFormat_1))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addGroup(groupLayout.createSequentialGroup()
							.addGap(5)
							.addComponent(lb_FilePath))
						.addGroup(groupLayout.createSequentialGroup()
							.addGap(3)
							.addComponent(tf_inputFile_1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
						.addComponent(btnChooseFile))
					.addGap(6)
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addGroup(groupLayout.createSequentialGroup()
							.addGap(5)
							.addComponent(lb_metadataFilePath))
						.addGroup(groupLayout.createSequentialGroup()
							.addGap(6)
							.addComponent(tf_metadataPath_1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
						.addComponent(btn_metadataChoose_1))
					.addGap(6)
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addGroup(groupLayout.createSequentialGroup()
							.addGap(5)
							.addComponent(lb_OutFilePath))
						.addGroup(groupLayout.createSequentialGroup()
							.addGap(3)
							.addComponent(tf_OutputFile_1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
						.addComponent(btn_ChooseOutputFile_1))
					.addGap(6)
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addComponent(lb_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, 23, GroupLayout.PREFERRED_SIZE)
						.addGroup(groupLayout.createSequentialGroup()
							.addGap(2)
							.addComponent(tf_pageBreakInlineStyle_1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addGroup(groupLayout.createSequentialGroup()
							.addGap(11)
							.addComponent(lb_type))
						.addGroup(groupLayout.createSequentialGroup()
							.addPreferredGap(ComponentPlacement.UNRELATED)
							.addComponent(cbox_type_1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
					.addGap(8)
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_Scale)
						.addComponent(tf_Scale_1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(10)
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_FilterLetterSpacing)
						.addComponent(tf_FilterLetterSpacing_1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(8)
					.addComponent(cb_InlineStyles_1)
					.addGap(6)
					.addComponent(cb_EmbedVectorImages_1)
					.addGap(6)
					.addComponent(cb_EmbedRaster_1)
					.addGap(6)
					.addComponent(cb_convertToPx_1)
					.addGap(6)
					.addComponent(cb_IgnoreHardLineBreaks_1)
					.addGap(6)
					.addComponent(cb_IgnoreEmptyParagraphs_1)
					.addGap(6)
					.addComponent(cb_UseMathJax_1)
					.addGap(6)
					.addComponent(cb_Pagination_1)
					.addGap(11)
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_ImageResolution, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
						.addComponent(cbox_image_resolution_1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addContainerGap())
		);
		setLayout(groupLayout);
	}

	private JButton addMetadataButton( JTextField tf_metadataPath) {
		btn_metadataChoose_1 = new JButton(Localizer.get(LABEL_BUTTON_CHOOSE));
		btn_metadataChoose_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String newFilePath = FileDialog.chooseFile(tf_metadataPath.getText(),CSV_FILE_EXTENSION);
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_metadataPath.setText(newFilePath);
				}
			}
		});
		return btn_metadataChoose_1;
	}

	private JTextField addMetadataPath(HashMap<String, Component> configuration) {
		tf_metadataPath_1 = new JTextField("");
		tf_metadataPath_1.setColumns(10);
		configuration.put(ARG_CSV_METADATA, tf_metadataPath_1);
		return tf_metadataPath_1;
	}

	private JButton addChooseFile( JTextField tf_OutputFile, JTextField tf_inputFile,
			JTextField tf_metadataPath) {
		btnChooseFile = new JButton(Localizer.get(LABEL_BUTTON_CHOOSE));
		btnChooseFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String newFilePath = FileDialog.chooseFile(tf_inputFile.getText(),ODT_FILE_EXTENSION);
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_inputFile.setText(newFilePath);
					setOutputFilePath(newFilePath,tf_OutputFile,RDF_FILE_EXTENSION);
					setMetadataFilePath(newFilePath,tf_metadataPath,CSV_FILE_EXTENSION);
				}
			}
		});
		return btnChooseFile;
	}

	private JComboBox addPubTypes(HashMap<String, Component> configuration, UIPreferences preferences) {
		cbox_type_1 = new JComboBox(preferences.getAll(PREF_PUBLICATION_TYPES));
		cbox_type_1.setSelectedIndex(Integer.parseInt(preferences.get(PREF_DEFAULT_PUBLICATION_TYPE)));
		configuration.put(ARG_RDF_TYPE, cbox_type_1);
		return cbox_type_1;
	}
	//Shared methods added here to make WindowBuilder work
	
	 JCheckBox addMathJaxCB(HashMap<String, Component> configuration, UIPreferences preferences) {
		cb_UseMathJax_1 = new JCheckBox(Localizer.get(LABEL_USE_MATHJAX));
		cb_UseMathJax_1.setSelected(Boolean.parseBoolean(preferences.get(PREF_USE_MATHJAX)));
		configuration.put(ARG_USE_MATHJAX, cb_UseMathJax_1);
		return cb_UseMathJax_1;
	}
	
	 JCheckBox addIgnoreEmptyParsCB(HashMap<String, Component> configuration, UIPreferences preferences) {
		cb_IgnoreEmptyParagraphs_1 = new JCheckBox(Localizer.get(LABEL_INGNORE_EMPTY_PARS));
		cb_IgnoreEmptyParagraphs_1.setSelected(Boolean.parseBoolean(preferences.get(PREF_IGNORE_EMPTY_PARS)));
		configuration.put(ARG_IGNORE_EMPTY_PARAGRAPHS, cb_IgnoreEmptyParagraphs_1);
		return cb_IgnoreEmptyParagraphs_1;
	}

	 JCheckBox addSplitWholePagesOnly(HashMap<String, Component> configuration, UIPreferences preferences) {
		JCheckBox cb_SplitWholePagesOnly = new JCheckBox(Localizer.get(LABEL_SPLIT_WHOLE_PAGES_ONLY));
		cb_SplitWholePagesOnly.setSelected(Boolean.parseBoolean(preferences.get(PREF_SPLIT_WHOLE_PAGES)));
		configuration.put(ARG_ALIGN_SPLITS_TO_PAGES, cb_SplitWholePagesOnly);
		return cb_SplitWholePagesOnly;
	}
	
	 JCheckBox addIgnoreHardLineBreaks(HashMap<String, Component> configuration, UIPreferences preferences) {
		cb_IgnoreHardLineBreaks_1 = new JCheckBox(Localizer.get(LABEL_FILETER_HARD_LINE_BREAKS));
		cb_IgnoreHardLineBreaks_1.setSelected(Boolean.parseBoolean(preferences.get(PREF_IGNORE_HARD_BREAKS)));
		configuration.put(ARG_IGNORE_HARD_LINE_BREAKS, cb_IgnoreHardLineBreaks_1);
		return cb_IgnoreHardLineBreaks_1;
	}

	 JTextField addLetterSpacingFilter(HashMap<String, Component> configuration, UIPreferences preferences) {
		tf_FilterLetterSpacing_1 = new JTextField();
		tf_FilterLetterSpacing_1.setText(preferences.get(PREF_LETTER_SPACING));
		configuration.put(ARG_MIN_LETTER_SPACING, tf_FilterLetterSpacing_1);
		tf_FilterLetterSpacing_1.setColumns(10);
		return tf_FilterLetterSpacing_1;
	}


	 JCheckBox addInlineStyles(HashMap<String, Component> configuration, UIPreferences preferences) {
		cb_InlineStyles_1 = new JCheckBox(Localizer.get(LABEL_INLINE_STYLES));
		cb_InlineStyles_1.setSelected(Boolean.parseBoolean(preferences.get(PREF_INLINE_STYLES)));
		configuration.put(ARG_CSS_INLINE, cb_InlineStyles_1);
		return cb_InlineStyles_1;
	}
	
	 JCheckBox addGreenstoneTags(HashMap<String, Component> configuration, UIPreferences preferences) {
		JCheckBox cb_Greenstone = new JCheckBox(Localizer.get(LABEL_GREENSTONE_SPLIT));
		configuration.put(ARG_GREENSTONE, cb_Greenstone);
		cb_Greenstone.setSelected(Boolean.parseBoolean(preferences.get(PREF_GREENSTONE_TAGS)));
		return cb_Greenstone;
	}

	 JTextField addOutputFileTextField(HashMap<String, Component> configuration, UIPreferences preferences) {
		tf_OutputFile_1 = new JTextField("");
		configuration.put(ARG_OUTPUT_FILE, tf_OutputFile_1);
		tf_OutputFile_1.setColumns(10);
		return tf_OutputFile_1;
	}

	 JCheckBox addPagination(HashMap<String, Component> configuration, UIPreferences preferences) {
		cb_Pagination_1 = new JCheckBox(Localizer.get(LABEL_PAGINATION));
		cb_Pagination_1.setSelected(Boolean.getBoolean(preferences.get(PREF_PAGINATION)));
		configuration.put(ARG_PAGINATION, cb_Pagination_1);
		return cb_Pagination_1;
	}
	
	 JCheckBox addConvertToPX(HashMap<String, Component> configuration, UIPreferences preferences) {
		cb_convertToPx_1 = new JCheckBox(Localizer.get(LABEL_CONVERT_TO_PX));
		cb_convertToPx_1.setSelected(Boolean.getBoolean(preferences.get(PREF_CONVERT_TO_PX)));
		configuration.put(ARG_CONVERT_TO_PX, cb_convertToPx_1);
		return cb_convertToPx_1;
	}

	 JTextField addPageBreakStyle(HashMap<String, Component> configuration, UIPreferences preferences) {
		tf_pageBreakInlineStyle_1 = new JTextField(preferences.get(PREF_PAGEBREAK_STYLES));
		tf_pageBreakInlineStyle_1.setColumns(10);
		configuration.put(ARG_PAGE_BREAK_STYLE, tf_pageBreakInlineStyle_1);
		return tf_pageBreakInlineStyle_1;
	}

	 JLabel addTargetFormat(String format, HashMap<String, Component> configuration) {
		lb_TargetFormat_1 = new JLabel(format);
		configuration.put(ARG_TARGET_FORMAT, lb_TargetFormat_1);
		return lb_TargetFormat_1;
	}

	 JTextField addScaling(HashMap<String, Component> configuration, UIPreferences preferences) {
		tf_Scale_1 = new JTextField();
		tf_Scale_1.setText(preferences.get(PREF_SCALING));
		tf_Scale_1.setColumns(10);
		configuration.put(ARG_SCALING, tf_Scale_1);
		return tf_Scale_1;
	}
	
	 JTextField addInputFile(HashMap<String, Component> configuration, UIPreferences preferences) {
		tf_inputFile_1 = new JTextField(preferences.getSourceFileName());
		tf_inputFile_1.setColumns(10);
		configuration.put(ARG_INPUT_FILE, tf_inputFile_1);
		return tf_inputFile_1;
	}

	 JComboBox addImageResolution(HashMap<String, Component> configuration, UIPreferences preferences) {
		cbox_image_resolution_1 = new JComboBox(preferences.getAll(PREF_RESOLUTIONS));
		cbox_image_resolution_1.setSelectedIndex(Integer.parseInt(preferences.get(PREF_DEFAULT_IMAGE_RESOLUTION)));
		configuration.put(ARG_IMAGE_RESOLUTION, cbox_image_resolution_1);
		return cbox_image_resolution_1;
	}
	
	 JComboBox addSplitByLevel(HashMap<String, Component> configuration, UIPreferences preferences) {
		JComboBox cbox_SplitByLevel = new JComboBox(preferences.getAll(PREF_SPLIT_LEVELS));
		configuration.put(ARG_SPLIT_LEVEL, cbox_SplitByLevel);
		cbox_SplitByLevel.setSelectedIndex(Integer.parseInt(preferences.get(PREF_SPLIT_BY_LEVEL)));
		return cbox_SplitByLevel;
	}
	
	 JTextField addMaxWidth(HashMap<String, Component> configuration, UIPreferences preferences) {
		JTextField tf_MaxWidth = new JTextField(preferences.get(PREF_MAX_WIDTH));
		tf_MaxWidth.setColumns(10);
		configuration.put(ARG_MAX_WIDTH, tf_MaxWidth);
		return tf_MaxWidth;
	}
	
	 JCheckBox addEmbedRasterImages(HashMap<String, Component> configuration, UIPreferences preferences) {
		cb_EmbedRaster_1 = new JCheckBox(Localizer.get(LABEL_EMBED_RASTER));
		cb_EmbedRaster_1.setSelected(Boolean.parseBoolean(preferences.get(PREF_EMBED_RASTER)));
		configuration.put(ARG_EMBED_IMG, cb_EmbedRaster_1);
		return cb_EmbedRaster_1;
	}

	 JCheckBox addEmbedVectorImages(HashMap<String, Component> configuration, UIPreferences preferences) {
		cb_EmbedVectorImages_1 = new JCheckBox(Localizer.get(LABEL_EMBED_VECTOR));
		cb_EmbedVectorImages_1.setSelected(Boolean.parseBoolean(preferences.get(PREF_EMBED_VECTOR)));
		configuration.put(ARG_EMBED_SVG, cb_EmbedVectorImages_1);
		return cb_EmbedVectorImages_1;
	}
	
	 void setOutputFilePath(String newFilePath, JTextField tf_OutputFile, String extension) {

		File inputFile = new File(newFilePath);
		if (!inputFile.exists()) {
			return;
		}
		if (!inputFile.isDirectory()) {
			File parent = inputFile.getParentFile();
			if (parent == null) {
				return;
			}
			if (!parent.canWrite()) {
				JOptionPane.showMessageDialog(ConfigurationWindow.getSingleFrame(), Localizer.get(CANT_WRITE_MESSAGE));
			}
		}
		if (newFilePath.length() < 3) {
			return;
		}
		String exportPath;
		if (inputFile.isDirectory()) {
			exportPath = newFilePath;
			tf_OutputFile.setText(exportPath);
		} else {
			String importExt = newFilePath.substring(newFilePath.length() - 3, newFilePath.length()).toLowerCase();
			if (importExt.equals(ODT_FILE_EXTENSION)) {
				exportPath = newFilePath.substring(0, newFilePath.length() - 3) + extension;
				tf_OutputFile.setText(exportPath);
			}
		}
	}
	
	
	JButton addChooseOutputButton(JTextField tf_OutputFile, String fileExtension) {
		btn_ChooseOutputFile_1 = new JButton(Localizer.get(LABEL_BUTTON_CHOOSE));
		btn_ChooseOutputFile_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				FileDialog fileDialog = new FileDialog();
				String newFilePath = fileDialog.chooseFile(tf_OutputFile.getText(),fileExtension);
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_OutputFile.setText(newFilePath);
				}
			}
		});
		return btn_ChooseOutputFile_1;
	}
	
	public void setMetadataFilePath(String newFilePath, JTextField tf_MetadataFile, String extension) {
		
		File inputFile = new File(newFilePath);
		if (!inputFile.exists()) {
			return;
		}
		if (inputFile.isDirectory()) {
			tf_MetadataFile.setText(newFilePath);	
		} else {
			File parent = inputFile.getParentFile();
			if (parent == null) {
				return;
			}
			if (newFilePath.length() < 3) {
				return;
			}
			String importExt = newFilePath.substring(newFilePath.length()-3, newFilePath.length()).toLowerCase();
			if (importExt.equals(ODT_FILE_EXTENSION)) {
				String metadataPath = newFilePath.substring(0, newFilePath.length()-3) + extension;
				File metaFile = new File(metadataPath);
				if (metaFile.exists() && metaFile.canRead()){
					tf_MetadataFile.setText(metadataPath);	
				}	else {
					tf_MetadataFile.setText("");
				}
			}
		}
		
	}

}
