package w2phtml.pageSplitters;

import static w2phtml.office.XMLString.TEXT_BOOKMARK_START;
import static w2phtml.office.XMLString.TEXT_NOTE;
import static w2phtml.office.XMLString.TEXT_NOTE_BODY;
import static w2phtml.office.XMLString.TEXT_SOFT_PAGE_BREAK;
import static w2phtml.office.XMLString.TEXT_SPAN;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import pro.litvinovg.xml.Debug;
import w2phtml.office.OfficeReader;

public class ParagraphSplitter extends BasicSplitter implements ISplitter {

	public ParagraphSplitter(OfficeReader officeReader, SplitFactory factory) {
		super(officeReader, factory);
		// TODO Auto-generated constructor stub
	}

	@Override
	public SplitResults Split(Node para) {
		Node parent = para.getParentNode();
		//System.out.println("PRINT PARA START");
		//Debug.prettyPrintXml(parent);
		SplitResults results = new SplitResults(false);
		Node paraFirstPart = para.cloneNode(false);
		int i = 0;
		NodeList childs = para.getChildNodes();
		while (childs.getLength() > i) {
			//System.out.println("In WHILE HANDLE PARA");
			Node child = childs.item(i);
			//NOT TEXT NODES
				if (containsSPB(child)){
					String childName = child.getNodeName();
					//System.out.println(childName);
					if (childName.equals(TEXT_SOFT_PAGE_BREAK)){
						//removeSPB
						//System.out.println("REMOVE SPB");
						para.removeChild(child);
					} else 
					if (childName.equals(TEXT_NOTE)){
						Element textNote = (Element) child;
					//System.out.println("handle TextNote in para");
						factory.split(textNote.getElementsByTagName(TEXT_NOTE_BODY).item(0));
					} else
					if (childName.equals(TEXT_SPAN)){
						factory.split(child);
					}	else {
						//Debug.printNode(child);
						System.out.println("ERROR: SPB INSIDE Paragraph Element in inner element " + childName);
  					System.exit(1);
					}
					break;
				//Other elements
				} else if (child.getNodeName() != null && child.getNodeName().equals(TEXT_BOOKMARK_START)){
					paraFirstPart.appendChild(child.cloneNode(true));
					i++;
				} else	{
					results.setDataMoved(true);
					paraFirstPart.appendChild(child);
				}
				//TEXT NODES
						
		}
		addHyphen(para,paraFirstPart);

		if (results.isDataMoved()) {
			removeIndent(para);
			parent.insertBefore(paraFirstPart, para);
		}
		//System.out.println("PRINT PARA END");
		//Debug.prettyPrintXml(parent);
		return results;
	}

}
